
;procedures for error messages, printing

include	c:\asm\include\macro.inc
Public	error_handling	;1= error_handling( called by macros on carry set)
			;(this is the one for real programs)
Public	write_file_device;3=write file or device( called by macro write_string)
Public	print_string	;2= print_string(called by macro print_message)
Public	value16string	;4= makes a 16 bit hexstring

code_seg segment word public 'code'
assume	cs:code_seg, ds:data_seg

print_string	proc	near
;ds[si] points to c+ string(asciz) of message
	push	ax
	push	bx
	mov	ah,	0eh
print_it:	
	mov	al,	[si]
	cmp	al,	0
	jz	print_string_done
	int	10h
	inc	si
	jmp	print_it
print_string_done:
	pop	bx
	pop	ax
	ret
print_string	endp

write_file_device	proc
	push	ax
	push	bx
	push	cx
	push	dx
	mov	ah,	40h
	int	21h
	cmp	cx,	ax
	jz	wfd_done
	stc			;set carry if not equal
wfd_done:
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
write_file_device	endp
	

value16string	proc
	
	push	ax
	push	cx
	push	dx
	
	mov	dl,	al

	mov	al,	ah
	mov	cl,	4
	shr	al,	cl
	cmp	al,	0ah
	sbb	al,	69h
	das
	mov	[si], al
	
	mov	al,	ah
	and	al,	0fh
	cmp	al,	0ah
	sbb	al,	69h
	das
	mov	[si][1], al
	
	mov	al,	dl
	mov	ah,	al

	mov	cl,	4
	shr	al,	cl
	cmp	al,	0ah
	sbb	al,	69h
	das
	mov	[si][2],al
	
	mov	al,	ah
	and	al,	0fh
	cmp	al,	0ah
	sbb	al,	69h
	das
	mov	[si][3], al
	mov	byte ptr[si][4], 0

	pop	dx
	pop	cx
	pop	ax	
	
	ret

value16string	endp


error_handling proc	near
;more elaborated handling with appropriate strings
;ax points to error
;error_message points to a table of zero terminated strings
;error_table points to a table of errors,errormessageoffsets

	push	ax
	mov	bx,	ax		;save it for table
	lea	si,	error_table
seek_error:
	lodsw	
	cmp	ax,	0
	jz	found_error
	cmp	ax,	bx
	jz	found_error
	add	si,	2
	jmp	seek_error
found_error:
	mov	si,	[si]
	mov	ah,	0eh
print_errm:	
	lodsb
	cmp	al,	0
	jz	error_message_done
	int	10h
	jmp	print_errm
error_message_done:
	pop	ax
	ret
error_handling	endp

code_seg ends

data_seg segment word public 'data'

public	valuestring

;default 'heap' for value strings( even binary ones)
valuestring	db	32	dup(?)

error_table		label	byte
	dw	01h,  offset(err_01)
	dw	02h,  offset(err_02)
	dw	03h,  offset(err_03)
	dw	04h,  offset(err_04)
	dw	05h,  offset(err_05)
	dw	06h,  offset(err_06)
	dw	07h,  offset(err_07)
	dw	08h,  offset(err_08)
	dw	09h,  offset(err_09)
	dw	0Ah,  offset(err_0A)
	dw	0Bh,  offset(err_0B) 
	dw	0Ch,  offset(err_0C)
	dw	0Dh,  offset(err_0D)
	dw	0Eh,  offset(err_0E)
	dw	0Fh,  offset(err_0F)
	dw	10h,  offset(err_10)
	dw	11h,  offset(err_11)
	dw	12h,  offset(err_12)
	dw	13h,  offset(err_13)
	dw	14h,  offset(err_14)
	dw	15h,  offset(err_15)
	dw	16h,  offset(err_16)
	dw	17h,  offset(err_17)
	dw	18h,  offset(err_18)
	dw	19h,  offset(err_19)
	dw	1Ah,  offset(err_1A)
	dw	1Bh,  offset(err_1B)
	dw	1Ch,  offset(err_1C)
	dw	1Dh,  offset(err_1D)
	dw	1Eh,  offset(err_1E)
	dw	1Fh,  offset(err_1F)
	dw	20h,  offset(err_20)
	dw	21h,  offset(err_21)
	dw	22h,  offset(err_22)
	dw	23h,  offset(err_23)
	dw	24h,  offset(err_24)
	dw	26h,  offset(err_26)
	dw	32h,  offset(err_32)
	dw	33h,  offset(err_33)
	dw	34h,  offset(err_34)
	dw	35h,  offset(err_35)
	dw	36h,  offset(err_36)
	dw	37h,  offset(err_37)
	dw	38h,  offset(err_38)
	dw	39h,  offset(err_39)
	dw	3Ah,  offset(err_3A)
	dw	3Bh,  offset(err_3B)
	dw	3Ch,  offset(err_3C)
	dw	3Dh,  offset(err_3D)
	dw	3Eh,  offset(err_3E)
	dw	3Fh,  offset(err_3F)
	dw	40h,  offset(err_40)
	dw	41h,  offset(err_41)
	dw	42h,  offset(err_42)
	dw	43h,  offset(err_43)
	dw	44h,  offset(err_44)
	dw	45h,  offset(err_45)
	dw	46h,  offset(err_46)
	dw	47h,  offset(err_47)
	dw	48h,  offset(err_48)
	dw	50h,  offset(err_50)
	dw	52h,  offset(err_52)
	dw	53h,  offset(err_53)
	dw	54h,  offset(err_54)
	dw	55h,  offset(err_55)
	dw	56h,  offset(err_56)
	dw	57h,  offset(err_57)
	dw	58h,  offset(err_58)
	dw	59h,  offset(err_59)
	dw	5Ah,  offset(err_5A)
	dw	0,	offset(err_unknown)

;error_messages	label	byte

err_01		db	'Invalid function number(01h)',0
err_02		db	'File not found(02h)',0
err_03		db	'Path not found(03h)',0
err_04		db	'Too many open files (no handles left)(04h)',0
err_05  	db	'Access denied(05h)',0
err_06  	db	'Invalid handle(06h)',0
err_07  	db	'Memory control blocks destroyed(07h)',0
err_08  	db	'Insufficient memory(08h)',0
err_09  	db	'Invalid memory block address(09h)',0
err_0A  	db	'Invalid environment(0ah)',0
err_0B		db	'Invalid format(0bh)',0
err_0C  	db	'Invalid access mode (open mode is invalid)(0ch)',0
err_0D  	db	'Invalid data(0dh)',0
err_0E  	db	'Reserved(0eh)',0
err_0F  	db	'Invalid drive specified(0fh)',0
err_10  	db	'Attempt to remove current directory(10h)',0
err_11  	db	'Not same device(11h)',0
err_12  	db	'No more files(12h)',0
err_13  	db	'Attempt to write on a write-protected diskette(12h)',0
err_14  	db	'Unknown unit(14h)',0
err_15  	db	'Drive not ready(15h)',0
err_16  	db	'Unknown command(16h)',0
err_17  	db	'CRC error(17h)',0
err_18  	db	'Bad request structure length(18h)',0
err_19  	db	'Seek error(19h)',0
err_1A  	db	'Unknown media type(1ah)',0
err_1B  	db	'Sector not found(1bh)',0
err_1C  	db	'Printer out of paper(1ch)',0
err_1D  	db	'Write fault(1dh)',0
err_1E  	db	'Read fault(1eh)',0
err_1F  	db	'General failure(1fh)',0
err_20  	db	'Sharing violation(20h)',0
err_21  	db	'Lock violation(21h)',0
err_22  	db	'Invalid disk change(22h)',0
err_23  	db	'FCB unavailable(23h)',0
err_24  	db	'Sharing buffer overflow(24h)',0
err_26  	db	'Unable to complete file operation (DOS 4.x)(26h)',0
err_32  	db	'Network request not supported(32h)',0
err_33  	db	'Remote computer not listening(33h)',0
err_34  	db	'Duplicate name on network(34h)',0
err_35  	db	'Network name not found(35h)',0
err_36  	db	'Network busy(36h)',0
err_37  	db	'Network device no longer exists(37h)',0
err_38  	db	'NetBIOS command limit exceeded(38h)',0
err_39  	db	'Network adapter error(39h)',0
err_3A  	db	'Incorrect network response(3ah)',0
err_3B  	db	'Unexpected network error(3bh)',0
err_3C  	db	'Incompatible remote adapter(3ch)',0
err_3D  	db	'Print queue full(3dh)',0
err_3E  	db	'No space for print file(3eh)',0
err_3F  	db	'Print file deleted(3fh)',0
err_40  	db	'Network name deleted(40h)',0
err_41  	db	'Access denied(41h)',0
err_42  	db	'Network device type incorrect(42h)',0
err_43  	db	'Network name not found(43h)',0
err_44  	db	'Network name limit exceeded(44h)',0
err_45 		db	'NetBIOS session limit exceeded(45h)',0
err_46  	db	'Temporarily paused(46h)',0
err_47  	db	'Network request not accepted(47h)',0
err_48  	db	'Print or disk redirection is paused(48h)',0
err_50  	db	'File already exists(50h)',0
err_52		db  	'Cannot make directory entry(52h)',0
err_53  	db	'Fail on INT 24(53h)',0
err_54  	db	'Too many redirections(54h)',0
err_55  	db	'Duplicate redirection(55h)',0
err_56  	db	'Invalid password(56h)',0
err_57  	db	'Invalid parameter(57h)',0
err_58  	db	'Network device fault(58h)',0
err_59  	db	'Function not supported by network (DOS 4.x)(59h)',0
err_5A  	db	'Required system component not installed (DOS 4.x)(5ah)',0
err_unknown	db	'Unknown DOS error(mostly programmers error!)',0

data_seg ends
	
	
end
